/* KeybindingManager.c generated by valac 0.22.1, the Vala compiler
 * generated from KeybindingManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 * Copyright (c) 2013-2014 Birdie Developers (http://birdieapp.github.io)
 *
 * This software is licensed under the GNU General Public License
 * (version 3 or later). See the COPYING file in this distribution.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Oliver Sauder <os@esite.ch>
 *              Ivo Nunes <ivoavnunes@gmail.com>
 *              Vasco Nunes <vascomfnunes@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>
#include <X11/extensions/XTest.h>
#include <gobject/gvaluecollector.h>


#define BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER (birdie_utils_keybinding_manager_get_type ())
#define BIRDIE_UTILS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER, BirdieUtilsKeybindingManager))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER, BirdieUtilsKeybindingManagerClass))
#define BIRDIE_UTILS_IS_KEYBINDING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER))
#define BIRDIE_UTILS_IS_KEYBINDING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER, BirdieUtilsKeybindingManagerClass))

typedef struct _BirdieUtilsKeybindingManager BirdieUtilsKeybindingManager;
typedef struct _BirdieUtilsKeybindingManagerClass BirdieUtilsKeybindingManagerClass;
typedef struct _BirdieUtilsKeybindingManagerPrivate BirdieUtilsKeybindingManagerPrivate;

#define BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING (birdie_utils_keybinding_manager_keybinding_get_type ())
#define BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, BirdieUtilsKeybindingManagerKeybinding))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, BirdieUtilsKeybindingManagerKeybindingClass))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING))
#define BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, BirdieUtilsKeybindingManagerKeybindingClass))

typedef struct _BirdieUtilsKeybindingManagerKeybinding BirdieUtilsKeybindingManagerKeybinding;
typedef struct _BirdieUtilsKeybindingManagerKeybindingClass BirdieUtilsKeybindingManagerKeybindingClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _birdie_utils_keybinding_manager_keybinding_unref0(var) ((var == NULL) ? NULL : (var = (birdie_utils_keybinding_manager_keybinding_unref (var), NULL)))
typedef struct _BirdieUtilsKeybindingManagerKeybindingPrivate BirdieUtilsKeybindingManagerKeybindingPrivate;
typedef struct _BirdieUtilsKeybindingManagerParamSpecKeybinding BirdieUtilsKeybindingManagerParamSpecKeybinding;

struct _BirdieUtilsKeybindingManager {
	GObject parent_instance;
	BirdieUtilsKeybindingManagerPrivate * priv;
};

struct _BirdieUtilsKeybindingManagerClass {
	GObjectClass parent_class;
};

struct _BirdieUtilsKeybindingManagerPrivate {
	GeeList* bindings;
};

typedef void (*BirdieUtilsKeybindingManagerKeybindingHandlerFunc) (GdkEvent* event, void* user_data);
struct _BirdieUtilsKeybindingManagerKeybinding {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BirdieUtilsKeybindingManagerKeybindingPrivate * priv;
};

struct _BirdieUtilsKeybindingManagerKeybindingClass {
	GTypeClass parent_class;
	void (*finalize) (BirdieUtilsKeybindingManagerKeybinding *self);
};

struct _BirdieUtilsKeybindingManagerKeybindingPrivate {
	gchar* _accelerator;
	gint _keycode;
	GdkModifierType _modifiers;
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc _handler;
	gpointer _handler_target;
};

struct _BirdieUtilsKeybindingManagerParamSpecKeybinding {
	GParamSpec parent_instance;
};


static gpointer birdie_utils_keybinding_manager_parent_class = NULL;
static guint* birdie_utils_keybinding_manager_lock_modifiers;
static gint birdie_utils_keybinding_manager_lock_modifiers_length1;
static guint* birdie_utils_keybinding_manager_lock_modifiers = NULL;
static gint birdie_utils_keybinding_manager_lock_modifiers_length1 = 0;
static gint _birdie_utils_keybinding_manager_lock_modifiers_size_ = 0;
static gpointer birdie_utils_keybinding_manager_keybinding_parent_class = NULL;

GType birdie_utils_keybinding_manager_get_type (void) G_GNUC_CONST;
static gpointer birdie_utils_keybinding_manager_keybinding_ref (gpointer instance);
static void birdie_utils_keybinding_manager_keybinding_unref (gpointer instance);
static GParamSpec* birdie_utils_keybinding_manager_param_spec_keybinding (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void birdie_utils_keybinding_manager_value_set_keybinding (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void birdie_utils_keybinding_manager_value_take_keybinding (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer birdie_utils_keybinding_manager_value_get_keybinding (const GValue* value) G_GNUC_UNUSED;
static GType birdie_utils_keybinding_manager_keybinding_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define BIRDIE_UTILS_KEYBINDING_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER, BirdieUtilsKeybindingManagerPrivate))
enum  {
	BIRDIE_UTILS_KEYBINDING_MANAGER_DUMMY_PROPERTY
};
void birdie_utils_keybinding_manager_init (BirdieUtilsKeybindingManager* self);
static GdkFilterReturn birdie_utils_keybinding_manager_event_filter (BirdieUtilsKeybindingManager* self, GdkXEvent* gdk_xevent, GdkEvent* gdk_event);
static GdkFilterReturn _birdie_utils_keybinding_manager_event_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self);
void birdie_utils_keybinding_manager_bind (BirdieUtilsKeybindingManager* self, const gchar* accelerator, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target);
static BirdieUtilsKeybindingManagerKeybinding* birdie_utils_keybinding_manager_keybinding_new (const gchar* accelerator, gint keycode, GdkModifierType modifiers, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target);
static BirdieUtilsKeybindingManagerKeybinding* birdie_utils_keybinding_manager_keybinding_construct (GType object_type, const gchar* accelerator, gint keycode, GdkModifierType modifiers, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target);
void birdie_utils_keybinding_manager_unbind (BirdieUtilsKeybindingManager* self, const gchar* accelerator);
static const gchar* birdie_utils_keybinding_manager_keybinding_get_accelerator (BirdieUtilsKeybindingManagerKeybinding* self);
static gint birdie_utils_keybinding_manager_keybinding_get_keycode (BirdieUtilsKeybindingManagerKeybinding* self);
static GdkModifierType birdie_utils_keybinding_manager_keybinding_get_modifiers (BirdieUtilsKeybindingManagerKeybinding* self);
void birdie_utils_keybinding_manager_press (BirdieUtilsKeybindingManager* self, const gchar* accelerator);
static gboolean birdie_utils_keybinding_manager_perform_key_event (BirdieUtilsKeybindingManager* self, const gchar* accelerator, gboolean press, gulong delay);
void birdie_utils_keybinding_manager_release (BirdieUtilsKeybindingManager* self, const gchar* accelerator);
guint birdie_utils_keybinding_manager_remove_lockmodifiers (guint state);
static BirdieUtilsKeybindingManagerKeybindingHandlerFunc birdie_utils_keybinding_manager_keybinding_get_handler (BirdieUtilsKeybindingManagerKeybinding* self, gpointer* result_target);
BirdieUtilsKeybindingManager* birdie_utils_keybinding_manager_new (void);
BirdieUtilsKeybindingManager* birdie_utils_keybinding_manager_construct (GType object_type);
#define BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, BirdieUtilsKeybindingManagerKeybindingPrivate))
enum  {
	BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_DUMMY_PROPERTY
};
static void birdie_utils_keybinding_manager_keybinding_set_accelerator (BirdieUtilsKeybindingManagerKeybinding* self, const gchar* value);
static void birdie_utils_keybinding_manager_keybinding_set_keycode (BirdieUtilsKeybindingManagerKeybinding* self, gint value);
static void birdie_utils_keybinding_manager_keybinding_set_modifiers (BirdieUtilsKeybindingManagerKeybinding* self, GdkModifierType value);
static void birdie_utils_keybinding_manager_keybinding_set_handler (BirdieUtilsKeybindingManagerKeybinding* self, BirdieUtilsKeybindingManagerKeybindingHandlerFunc value, gpointer value_target);
static void birdie_utils_keybinding_manager_keybinding_finalize (BirdieUtilsKeybindingManagerKeybinding* obj);
static void birdie_utils_keybinding_manager_finalize (GObject* obj);


/**
         * initialize keybinding
         */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GdkFilterReturn _birdie_utils_keybinding_manager_event_filter_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self) {
	GdkFilterReturn result;
	result = birdie_utils_keybinding_manager_event_filter (self, xevent, event);
	return result;
}


void birdie_utils_keybinding_manager_init (BirdieUtilsKeybindingManager* self) {
	GdkWindow* rootwin = NULL;
	GdkWindow* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	GdkWindow* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_get_default_root_window ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	rootwin = _tmp1_;
	_tmp2_ = rootwin;
	if (_tmp2_ != NULL) {
		GdkWindow* _tmp3_ = NULL;
		_tmp3_ = rootwin;
		gdk_window_add_filter (_tmp3_, _birdie_utils_keybinding_manager_event_filter_gdk_filter_func, self);
	}
	_g_object_unref0 (rootwin);
}


/**
         * Bind accelerator to given handler
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         * @param handler handler called when given accelerator is pressed
         */
void birdie_utils_keybinding_manager_bind (BirdieUtilsKeybindingManager* self, const gchar* accelerator, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	guint keysym = 0U;
	GdkModifierType modifiers = 0;
	const gchar* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	GdkModifierType _tmp5_ = 0;
	Display* display = NULL;
	Display* _tmp6_ = NULL;
	gint keycode = 0;
	Display* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	guchar _tmp9_ = '\0';
	gint _tmp10_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = accelerator;
	_tmp1_ = g_strconcat ("Binding key ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("KeybindingManager.vala:90: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = accelerator;
	gtk_accelerator_parse (_tmp3_, &_tmp4_, &_tmp5_);
	keysym = _tmp4_;
	modifiers = _tmp5_;
	_tmp6_ = gdk_x11_get_default_xdisplay ();
	display = _tmp6_;
	_tmp7_ = display;
	_tmp8_ = keysym;
	_tmp9_ = XKeysymToKeycode (_tmp7_, (gulong) _tmp8_);
	keycode = (gint) _tmp9_;
	_tmp10_ = keycode;
	if (_tmp10_ != 0) {
		Window root_window = 0;
		Window _tmp11_ = 0;
		guint* _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		BirdieUtilsKeybindingManagerKeybinding* binding = NULL;
		const gchar* _tmp18_ = NULL;
		gint _tmp19_ = 0;
		GdkModifierType _tmp20_ = 0;
		BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp21_ = NULL;
		void* _tmp21__target = NULL;
		BirdieUtilsKeybindingManagerKeybinding* _tmp22_ = NULL;
		GeeList* _tmp23_ = NULL;
		BirdieUtilsKeybindingManagerKeybinding* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		_tmp11_ = gdk_x11_get_default_root_xwindow ();
		root_window = _tmp11_;
		gdk_error_trap_push ();
		_tmp12_ = birdie_utils_keybinding_manager_lock_modifiers;
		_tmp12__length1 = birdie_utils_keybinding_manager_lock_modifiers_length1;
		{
			guint* lock_modifier_collection = NULL;
			gint lock_modifier_collection_length1 = 0;
			gint _lock_modifier_collection_size_ = 0;
			gint lock_modifier_it = 0;
			lock_modifier_collection = _tmp12_;
			lock_modifier_collection_length1 = _tmp12__length1;
			for (lock_modifier_it = 0; lock_modifier_it < _tmp12__length1; lock_modifier_it = lock_modifier_it + 1) {
				guint lock_modifier = 0U;
				lock_modifier = lock_modifier_collection[lock_modifier_it];
				{
					Display* _tmp13_ = NULL;
					gint _tmp14_ = 0;
					GdkModifierType _tmp15_ = 0;
					guint _tmp16_ = 0U;
					Window _tmp17_ = 0;
					_tmp13_ = display;
					_tmp14_ = keycode;
					_tmp15_ = modifiers;
					_tmp16_ = lock_modifier;
					_tmp17_ = root_window;
					XGrabKey (_tmp13_, _tmp14_, (guint) (_tmp15_ | _tmp16_), _tmp17_, FALSE, (gint) GrabModeAsync, (gint) GrabModeAsync);
				}
			}
		}
		gdk_flush ();
		_tmp18_ = accelerator;
		_tmp19_ = keycode;
		_tmp20_ = modifiers;
		_tmp21_ = handler;
		_tmp21__target = handler_target;
		_tmp22_ = birdie_utils_keybinding_manager_keybinding_new (_tmp18_, _tmp19_, _tmp20_, _tmp21_, _tmp21__target);
		binding = _tmp22_;
		_tmp23_ = self->priv->bindings;
		_tmp24_ = binding;
		gee_collection_add ((GeeCollection*) _tmp23_, _tmp24_);
		_tmp25_ = accelerator;
		_tmp26_ = g_strconcat ("Successfully binded key ", _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		g_debug ("KeybindingManager.vala:121: %s", _tmp27_);
		_g_free0 (_tmp27_);
		_birdie_utils_keybinding_manager_keybinding_unref0 (binding);
	}
}


/**
         * Unbind given accelerator.
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         */
void birdie_utils_keybinding_manager_unbind (BirdieUtilsKeybindingManager* self, const gchar* accelerator) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	Display* display = NULL;
	Display* _tmp3_ = NULL;
	Window root_window = 0;
	Window _tmp4_ = 0;
	GeeList* remove_bindings = NULL;
	GeeArrayList* _tmp5_ = NULL;
	GeeList* _tmp34_ = NULL;
	GeeList* _tmp35_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = accelerator;
	_tmp1_ = g_strconcat ("Unbinding key ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("KeybindingManager.vala:132: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = gdk_x11_get_default_xdisplay ();
	display = _tmp3_;
	_tmp4_ = gdk_x11_get_default_root_xwindow ();
	root_window = _tmp4_;
	_tmp5_ = gee_array_list_new (BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, (GBoxedCopyFunc) birdie_utils_keybinding_manager_keybinding_ref, birdie_utils_keybinding_manager_keybinding_unref, NULL);
	remove_bindings = (GeeList*) _tmp5_;
	{
		GeeList* _binding_list = NULL;
		GeeList* _tmp6_ = NULL;
		GeeList* _tmp7_ = NULL;
		gint _binding_size = 0;
		GeeList* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _binding_index = 0;
		_tmp6_ = self->priv->bindings;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_binding_list = _tmp7_;
		_tmp8_ = _binding_list;
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_binding_size = _tmp10_;
		_binding_index = -1;
		while (TRUE) {
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			BirdieUtilsKeybindingManagerKeybinding* binding = NULL;
			GeeList* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gpointer _tmp16_ = NULL;
			GEqualFunc _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			BirdieUtilsKeybindingManagerKeybinding* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			gboolean _tmp22_ = FALSE;
			_tmp11_ = _binding_index;
			_binding_index = _tmp11_ + 1;
			_tmp12_ = _binding_index;
			_tmp13_ = _binding_size;
			if (!(_tmp12_ < _tmp13_)) {
				break;
			}
			_tmp14_ = _binding_list;
			_tmp15_ = _binding_index;
			_tmp16_ = gee_list_get (_tmp14_, _tmp15_);
			binding = (BirdieUtilsKeybindingManagerKeybinding*) _tmp16_;
			_tmp17_ = g_str_equal;
			_tmp18_ = accelerator;
			_tmp19_ = binding;
			_tmp20_ = birdie_utils_keybinding_manager_keybinding_get_accelerator (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = _tmp17_ (_tmp18_, _tmp21_);
			if (_tmp22_) {
				guint* _tmp23_ = NULL;
				gint _tmp23__length1 = 0;
				GeeList* _tmp32_ = NULL;
				BirdieUtilsKeybindingManagerKeybinding* _tmp33_ = NULL;
				_tmp23_ = birdie_utils_keybinding_manager_lock_modifiers;
				_tmp23__length1 = birdie_utils_keybinding_manager_lock_modifiers_length1;
				{
					guint* lock_modifier_collection = NULL;
					gint lock_modifier_collection_length1 = 0;
					gint _lock_modifier_collection_size_ = 0;
					gint lock_modifier_it = 0;
					lock_modifier_collection = _tmp23_;
					lock_modifier_collection_length1 = _tmp23__length1;
					for (lock_modifier_it = 0; lock_modifier_it < _tmp23__length1; lock_modifier_it = lock_modifier_it + 1) {
						guint lock_modifier = 0U;
						lock_modifier = lock_modifier_collection[lock_modifier_it];
						{
							Display* _tmp24_ = NULL;
							BirdieUtilsKeybindingManagerKeybinding* _tmp25_ = NULL;
							gint _tmp26_ = 0;
							gint _tmp27_ = 0;
							BirdieUtilsKeybindingManagerKeybinding* _tmp28_ = NULL;
							GdkModifierType _tmp29_ = 0;
							GdkModifierType _tmp30_ = 0;
							Window _tmp31_ = 0;
							_tmp24_ = display;
							_tmp25_ = binding;
							_tmp26_ = birdie_utils_keybinding_manager_keybinding_get_keycode (_tmp25_);
							_tmp27_ = _tmp26_;
							_tmp28_ = binding;
							_tmp29_ = birdie_utils_keybinding_manager_keybinding_get_modifiers (_tmp28_);
							_tmp30_ = _tmp29_;
							_tmp31_ = root_window;
							XUngrabKey (_tmp24_, _tmp27_, (guint) _tmp30_, _tmp31_);
						}
					}
				}
				_tmp32_ = remove_bindings;
				_tmp33_ = binding;
				gee_collection_add ((GeeCollection*) _tmp32_, _tmp33_);
			}
			_birdie_utils_keybinding_manager_keybinding_unref0 (binding);
		}
		_g_object_unref0 (_binding_list);
	}
	_tmp34_ = self->priv->bindings;
	_tmp35_ = remove_bindings;
	gee_collection_remove_all ((GeeCollection*) _tmp34_, (GeeCollection*) _tmp35_);
	_g_object_unref0 (remove_bindings);
}


/**
         * Press given accelerator on current display on the window which
         * has focus at the time given.
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         */
void birdie_utils_keybinding_manager_press (BirdieUtilsKeybindingManager* self, const gchar* accelerator) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = accelerator;
	_tmp1_ = birdie_utils_keybinding_manager_perform_key_event (self, _tmp0_, TRUE, (gulong) 100);
	if (_tmp1_) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp2_ = accelerator;
		_tmp3_ = g_strconcat ("Successfully pressed key ", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		g_debug ("KeybindingManager.vala:161: %s", _tmp4_);
		_g_free0 (_tmp4_);
	}
}


/**
         * Release given accelerator on current display on the window which
         * has focus at the time given.
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         */
void birdie_utils_keybinding_manager_release (BirdieUtilsKeybindingManager* self, const gchar* accelerator) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (accelerator != NULL);
	_tmp0_ = accelerator;
	_tmp1_ = birdie_utils_keybinding_manager_perform_key_event (self, _tmp0_, FALSE, (gulong) 0);
	if (_tmp1_) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp2_ = accelerator;
		_tmp3_ = g_strconcat ("Successfully released key ", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		g_debug ("KeybindingManager.vala:174: %s", _tmp4_);
		_g_free0 (_tmp4_);
	}
}


/**
         * Remove lock modifiers (NumLock, CapsLock, ScrollLock) from
         * key state
         *
         * @param state key state of a gdk event
         */
guint birdie_utils_keybinding_manager_remove_lockmodifiers (guint state) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	_tmp0_ = state;
	result = _tmp0_ & (~((GDK_MOD2_MASK | GDK_LOCK_MASK) | GDK_MOD5_MASK));
	return result;
}


/**
         * Helper method performing given accelerator on current active
         * window.
         *
         * @param accelerator accelerator parsable by Gtk.accelerator_parse
         * @param press true for press key; false for releasing
         * @param delay delay in milli seconds
         * @return true if creation was successful; otherwise false.
         */
static gboolean birdie_utils_keybinding_manager_perform_key_event (BirdieUtilsKeybindingManager* self, const gchar* accelerator, gboolean press, gulong delay) {
	gboolean result = FALSE;
	guint keysym = 0U;
	GdkModifierType modifiers = 0;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	Display* display = NULL;
	Display* _tmp3_ = NULL;
	gint keycode = 0;
	Display* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	guchar _tmp6_ = '\0';
	gint modifierykey = 0;
	GdkModifierType _tmp7_ = 0;
	gint modifiercode = 0;
	Display* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	guchar _tmp10_ = '\0';
	gint _tmp11_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (accelerator != NULL, FALSE);
	_tmp0_ = accelerator;
	gtk_accelerator_parse (_tmp0_, &_tmp1_, &_tmp2_);
	keysym = _tmp1_;
	modifiers = _tmp2_;
	_tmp3_ = gdk_x11_get_default_xdisplay ();
	display = _tmp3_;
	_tmp4_ = display;
	_tmp5_ = keysym;
	_tmp6_ = XKeysymToKeycode (_tmp4_, (gulong) _tmp5_);
	keycode = (gint) _tmp6_;
	modifierykey = 0;
	_tmp7_ = modifiers;
	switch (_tmp7_) {
		case GDK_CONTROL_MASK:
		{
			modifierykey = 0xffe3;
			break;
		}
		case GDK_SHIFT_MASK:
		{
			modifierykey = 0xffe1;
			break;
		}
		default:
		break;
	}
	_tmp8_ = display;
	_tmp9_ = modifierykey;
	_tmp10_ = XKeysymToKeycode (_tmp8_, (gulong) _tmp9_);
	modifiercode = (gint) _tmp10_;
	_tmp11_ = keycode;
	if (_tmp11_ != 0) {
		gint _tmp12_ = 0;
		Display* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		gboolean _tmp19_ = FALSE;
		gulong _tmp20_ = 0UL;
		_tmp12_ = modifiercode;
		if (_tmp12_ != 0) {
			Display* _tmp13_ = NULL;
			gint _tmp14_ = 0;
			gboolean _tmp15_ = FALSE;
			gulong _tmp16_ = 0UL;
			_tmp13_ = display;
			_tmp14_ = modifiercode;
			_tmp15_ = press;
			_tmp16_ = delay;
			XTestFakeKeyEvent (_tmp13_, (guint) _tmp14_, _tmp15_, _tmp16_);
		}
		_tmp17_ = display;
		_tmp18_ = keycode;
		_tmp19_ = press;
		_tmp20_ = delay;
		XTestFakeKeyEvent (_tmp17_, (guint) _tmp18_, _tmp19_, _tmp20_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


/**
         * Event filter method needed to fetch X.Events
         */
static GdkFilterReturn birdie_utils_keybinding_manager_event_filter (BirdieUtilsKeybindingManager* self, GdkXEvent* gdk_xevent, GdkEvent* gdk_event) {
	GdkFilterReturn result = 0;
	XEvent* xevent = NULL;
	GdkXEvent* _tmp0_ = NULL;
	XEvent* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (gdk_xevent != NULL, 0);
	g_return_val_if_fail (gdk_event != NULL, 0);
	_tmp0_ = gdk_xevent;
	xevent = (XEvent*) _tmp0_;
	_tmp1_ = xevent;
	_tmp2_ = (*_tmp1_).type;
	if (_tmp2_ == ((gint) KeyPress)) {
		XEvent* _tmp3_ = NULL;
		XKeyEvent _tmp4_ = {0};
		guint _tmp5_ = 0U;
		XEvent* _tmp6_ = NULL;
		XKeyEvent _tmp7_ = {0};
		guint _tmp8_ = 0U;
		_tmp3_ = xevent;
		_tmp4_ = (*_tmp3_).xkey;
		_tmp5_ = _tmp4_.keycode;
		_tmp6_ = xevent;
		_tmp7_ = (*_tmp6_).xkey;
		_tmp8_ = _tmp7_.state;
		g_debug ("KeybindingManager.vala:245: Key pressed, keycode: %u, modifiers: %u", _tmp5_, _tmp8_);
		{
			GeeList* _binding_list = NULL;
			GeeList* _tmp9_ = NULL;
			GeeList* _tmp10_ = NULL;
			gint _binding_size = 0;
			GeeList* _tmp11_ = NULL;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _binding_index = 0;
			_tmp9_ = self->priv->bindings;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			_binding_list = _tmp10_;
			_tmp11_ = _binding_list;
			_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_binding_size = _tmp13_;
			_binding_index = -1;
			while (TRUE) {
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				BirdieUtilsKeybindingManagerKeybinding* binding = NULL;
				GeeList* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				gpointer _tmp19_ = NULL;
				guint event_mods = 0U;
				XEvent* _tmp20_ = NULL;
				XKeyEvent _tmp21_ = {0};
				guint _tmp22_ = 0U;
				guint _tmp23_ = 0U;
				gboolean _tmp24_ = FALSE;
				XEvent* _tmp25_ = NULL;
				XKeyEvent _tmp26_ = {0};
				guint _tmp27_ = 0U;
				BirdieUtilsKeybindingManagerKeybinding* _tmp28_ = NULL;
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
				gboolean _tmp35_ = FALSE;
				_tmp14_ = _binding_index;
				_binding_index = _tmp14_ + 1;
				_tmp15_ = _binding_index;
				_tmp16_ = _binding_size;
				if (!(_tmp15_ < _tmp16_)) {
					break;
				}
				_tmp17_ = _binding_list;
				_tmp18_ = _binding_index;
				_tmp19_ = gee_list_get (_tmp17_, _tmp18_);
				binding = (BirdieUtilsKeybindingManagerKeybinding*) _tmp19_;
				_tmp20_ = xevent;
				_tmp21_ = (*_tmp20_).xkey;
				_tmp22_ = _tmp21_.state;
				_tmp23_ = birdie_utils_keybinding_manager_remove_lockmodifiers (_tmp22_);
				event_mods = _tmp23_;
				_tmp25_ = xevent;
				_tmp26_ = (*_tmp25_).xkey;
				_tmp27_ = _tmp26_.keycode;
				_tmp28_ = binding;
				_tmp29_ = birdie_utils_keybinding_manager_keybinding_get_keycode (_tmp28_);
				_tmp30_ = _tmp29_;
				if (_tmp27_ == ((guint) _tmp30_)) {
					guint _tmp31_ = 0U;
					BirdieUtilsKeybindingManagerKeybinding* _tmp32_ = NULL;
					GdkModifierType _tmp33_ = 0;
					GdkModifierType _tmp34_ = 0;
					_tmp31_ = event_mods;
					_tmp32_ = binding;
					_tmp33_ = birdie_utils_keybinding_manager_keybinding_get_modifiers (_tmp32_);
					_tmp34_ = _tmp33_;
					_tmp24_ = _tmp31_ == ((guint) _tmp34_);
				} else {
					_tmp24_ = FALSE;
				}
				_tmp35_ = _tmp24_;
				if (_tmp35_) {
					BirdieUtilsKeybindingManagerKeybinding* _tmp36_ = NULL;
					const gchar* _tmp37_ = NULL;
					const gchar* _tmp38_ = NULL;
					BirdieUtilsKeybindingManagerKeybinding* _tmp39_ = NULL;
					BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp40_ = NULL;
					void* _tmp40__target = NULL;
					BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp41_ = NULL;
					void* _tmp41__target = NULL;
					GdkEvent* _tmp42_ = NULL;
					_tmp36_ = binding;
					_tmp37_ = birdie_utils_keybinding_manager_keybinding_get_accelerator (_tmp36_);
					_tmp38_ = _tmp37_;
					g_debug ("KeybindingManager.vala:251: Keybinding hit with accelerator %s", _tmp38_);
					_tmp39_ = binding;
					_tmp40_ = birdie_utils_keybinding_manager_keybinding_get_handler (_tmp39_, &_tmp40__target);
					_tmp41_ = _tmp40_;
					_tmp41__target = _tmp40__target;
					_tmp42_ = gdk_event;
					_tmp41_ (_tmp42_, _tmp41__target);
					result = GDK_FILTER_REMOVE;
					_birdie_utils_keybinding_manager_keybinding_unref0 (binding);
					_g_object_unref0 (_binding_list);
					return result;
				}
				_birdie_utils_keybinding_manager_keybinding_unref0 (binding);
			}
			_g_object_unref0 (_binding_list);
		}
	}
	result = GDK_FILTER_CONTINUE;
	return result;
}


BirdieUtilsKeybindingManager* birdie_utils_keybinding_manager_construct (GType object_type) {
	BirdieUtilsKeybindingManager * self = NULL;
	self = (BirdieUtilsKeybindingManager*) g_object_new (object_type, NULL);
	return self;
}


BirdieUtilsKeybindingManager* birdie_utils_keybinding_manager_new (void) {
	return birdie_utils_keybinding_manager_construct (BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER);
}


static BirdieUtilsKeybindingManagerKeybinding* birdie_utils_keybinding_manager_keybinding_construct (GType object_type, const gchar* accelerator, gint keycode, GdkModifierType modifiers, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target) {
	BirdieUtilsKeybindingManagerKeybinding* self = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkModifierType _tmp2_ = 0;
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp3_ = NULL;
	void* _tmp3__target = NULL;
	g_return_val_if_fail (accelerator != NULL, NULL);
	self = (BirdieUtilsKeybindingManagerKeybinding*) g_type_create_instance (object_type);
	_tmp0_ = accelerator;
	birdie_utils_keybinding_manager_keybinding_set_accelerator (self, _tmp0_);
	_tmp1_ = keycode;
	birdie_utils_keybinding_manager_keybinding_set_keycode (self, _tmp1_);
	_tmp2_ = modifiers;
	birdie_utils_keybinding_manager_keybinding_set_modifiers (self, _tmp2_);
	_tmp3_ = handler;
	_tmp3__target = handler_target;
	birdie_utils_keybinding_manager_keybinding_set_handler (self, _tmp3_, _tmp3__target);
	return self;
}


static BirdieUtilsKeybindingManagerKeybinding* birdie_utils_keybinding_manager_keybinding_new (const gchar* accelerator, gint keycode, GdkModifierType modifiers, BirdieUtilsKeybindingManagerKeybindingHandlerFunc handler, void* handler_target) {
	return birdie_utils_keybinding_manager_keybinding_construct (BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, accelerator, keycode, modifiers, handler, handler_target);
}


static const gchar* birdie_utils_keybinding_manager_keybinding_get_accelerator (BirdieUtilsKeybindingManagerKeybinding* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_accelerator;
	result = _tmp0_;
	return result;
}


static void birdie_utils_keybinding_manager_keybinding_set_accelerator (BirdieUtilsKeybindingManagerKeybinding* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_accelerator);
	self->priv->_accelerator = _tmp1_;
}


static gint birdie_utils_keybinding_manager_keybinding_get_keycode (BirdieUtilsKeybindingManagerKeybinding* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_keycode;
	result = _tmp0_;
	return result;
}


static void birdie_utils_keybinding_manager_keybinding_set_keycode (BirdieUtilsKeybindingManagerKeybinding* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_keycode = _tmp0_;
}


static GdkModifierType birdie_utils_keybinding_manager_keybinding_get_modifiers (BirdieUtilsKeybindingManagerKeybinding* self) {
	GdkModifierType result;
	GdkModifierType _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


static void birdie_utils_keybinding_manager_keybinding_set_modifiers (BirdieUtilsKeybindingManagerKeybinding* self, GdkModifierType value) {
	GdkModifierType _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_modifiers = _tmp0_;
}


static BirdieUtilsKeybindingManagerKeybindingHandlerFunc birdie_utils_keybinding_manager_keybinding_get_handler (BirdieUtilsKeybindingManagerKeybinding* self, gpointer* result_target) {
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc result;
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_handler;
	_tmp0__target = self->priv->_handler_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


static void birdie_utils_keybinding_manager_keybinding_set_handler (BirdieUtilsKeybindingManagerKeybinding* self, BirdieUtilsKeybindingManagerKeybindingHandlerFunc value, gpointer value_target) {
	BirdieUtilsKeybindingManagerKeybindingHandlerFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	self->priv->_handler = _tmp0_;
	self->priv->_handler_target = _tmp0__target;
}


static void birdie_utils_keybinding_manager_value_keybinding_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void birdie_utils_keybinding_manager_value_keybinding_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		birdie_utils_keybinding_manager_keybinding_unref (value->data[0].v_pointer);
	}
}


static void birdie_utils_keybinding_manager_value_keybinding_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = birdie_utils_keybinding_manager_keybinding_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer birdie_utils_keybinding_manager_value_keybinding_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* birdie_utils_keybinding_manager_value_keybinding_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BirdieUtilsKeybindingManagerKeybinding* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = birdie_utils_keybinding_manager_keybinding_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* birdie_utils_keybinding_manager_value_keybinding_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BirdieUtilsKeybindingManagerKeybinding** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = birdie_utils_keybinding_manager_keybinding_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* birdie_utils_keybinding_manager_param_spec_keybinding (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	BirdieUtilsKeybindingManagerParamSpecKeybinding* spec;
	g_return_val_if_fail (g_type_is_a (object_type, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer birdie_utils_keybinding_manager_value_get_keybinding (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING), NULL);
	return value->data[0].v_pointer;
}


static void birdie_utils_keybinding_manager_value_set_keybinding (GValue* value, gpointer v_object) {
	BirdieUtilsKeybindingManagerKeybinding* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		birdie_utils_keybinding_manager_keybinding_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_utils_keybinding_manager_keybinding_unref (old);
	}
}


static void birdie_utils_keybinding_manager_value_take_keybinding (GValue* value, gpointer v_object) {
	BirdieUtilsKeybindingManagerKeybinding* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_utils_keybinding_manager_keybinding_unref (old);
	}
}


static void birdie_utils_keybinding_manager_keybinding_class_init (BirdieUtilsKeybindingManagerKeybindingClass * klass) {
	birdie_utils_keybinding_manager_keybinding_parent_class = g_type_class_peek_parent (klass);
	BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_CLASS (klass)->finalize = birdie_utils_keybinding_manager_keybinding_finalize;
	g_type_class_add_private (klass, sizeof (BirdieUtilsKeybindingManagerKeybindingPrivate));
}


static void birdie_utils_keybinding_manager_keybinding_instance_init (BirdieUtilsKeybindingManagerKeybinding * self) {
	self->priv = BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void birdie_utils_keybinding_manager_keybinding_finalize (BirdieUtilsKeybindingManagerKeybinding* obj) {
	BirdieUtilsKeybindingManagerKeybinding * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, BirdieUtilsKeybindingManagerKeybinding);
	_g_free0 (self->priv->_accelerator);
}


/**
         * Helper class to store keybinding
         */
static GType birdie_utils_keybinding_manager_keybinding_get_type (void) {
	static volatile gsize birdie_utils_keybinding_manager_keybinding_type_id__volatile = 0;
	if (g_once_init_enter (&birdie_utils_keybinding_manager_keybinding_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { birdie_utils_keybinding_manager_value_keybinding_init, birdie_utils_keybinding_manager_value_keybinding_free_value, birdie_utils_keybinding_manager_value_keybinding_copy_value, birdie_utils_keybinding_manager_value_keybinding_peek_pointer, "p", birdie_utils_keybinding_manager_value_keybinding_collect_value, "p", birdie_utils_keybinding_manager_value_keybinding_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BirdieUtilsKeybindingManagerKeybindingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) birdie_utils_keybinding_manager_keybinding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BirdieUtilsKeybindingManagerKeybinding), 0, (GInstanceInitFunc) birdie_utils_keybinding_manager_keybinding_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType birdie_utils_keybinding_manager_keybinding_type_id;
		birdie_utils_keybinding_manager_keybinding_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BirdieUtilsKeybindingManagerKeybinding", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&birdie_utils_keybinding_manager_keybinding_type_id__volatile, birdie_utils_keybinding_manager_keybinding_type_id);
	}
	return birdie_utils_keybinding_manager_keybinding_type_id__volatile;
}


static gpointer birdie_utils_keybinding_manager_keybinding_ref (gpointer instance) {
	BirdieUtilsKeybindingManagerKeybinding* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void birdie_utils_keybinding_manager_keybinding_unref (gpointer instance) {
	BirdieUtilsKeybindingManagerKeybinding* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BIRDIE_UTILS_KEYBINDING_MANAGER_KEYBINDING_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void birdie_utils_keybinding_manager_class_init (BirdieUtilsKeybindingManagerClass * klass) {
	guint* _tmp0_ = NULL;
	birdie_utils_keybinding_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BirdieUtilsKeybindingManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = birdie_utils_keybinding_manager_finalize;
	_tmp0_ = g_new0 (guint, 8);
	_tmp0_[0] = (guint) 0;
	_tmp0_[1] = (guint) GDK_MOD2_MASK;
	_tmp0_[2] = (guint) GDK_LOCK_MASK;
	_tmp0_[3] = (guint) GDK_MOD5_MASK;
	_tmp0_[4] = (guint) (GDK_MOD2_MASK | GDK_LOCK_MASK);
	_tmp0_[5] = (guint) (GDK_MOD2_MASK | GDK_MOD5_MASK);
	_tmp0_[6] = (guint) (GDK_LOCK_MASK | GDK_MOD5_MASK);
	_tmp0_[7] = (guint) ((GDK_MOD2_MASK | GDK_LOCK_MASK) | GDK_MOD5_MASK);
	birdie_utils_keybinding_manager_lock_modifiers = _tmp0_;
	birdie_utils_keybinding_manager_lock_modifiers_length1 = 8;
}


static void birdie_utils_keybinding_manager_instance_init (BirdieUtilsKeybindingManager * self) {
	GeeArrayList* _tmp0_ = NULL;
	self->priv = BIRDIE_UTILS_KEYBINDING_MANAGER_GET_PRIVATE (self);
	_tmp0_ = gee_array_list_new (BIRDIE_UTILS_KEYBINDING_MANAGER_TYPE_KEYBINDING, (GBoxedCopyFunc) birdie_utils_keybinding_manager_keybinding_ref, birdie_utils_keybinding_manager_keybinding_unref, NULL);
	self->priv->bindings = (GeeList*) _tmp0_;
}


static void birdie_utils_keybinding_manager_finalize (GObject* obj) {
	BirdieUtilsKeybindingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BIRDIE_UTILS_TYPE_KEYBINDING_MANAGER, BirdieUtilsKeybindingManager);
	_g_object_unref0 (self->priv->bindings);
	G_OBJECT_CLASS (birdie_utils_keybinding_manager_parent_class)->finalize (obj);
}


GType birdie_utils_keybinding_manager_get_type (void) {
	static volatile gsize birdie_utils_keybinding_manager_type_id__volatile = 0;
	if (g_once_init_enter (&birdie_utils_keybinding_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BirdieUtilsKeybindingManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) birdie_utils_keybinding_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BirdieUtilsKeybindingManager), 0, (GInstanceInitFunc) birdie_utils_keybinding_manager_instance_init, NULL };
		GType birdie_utils_keybinding_manager_type_id;
		birdie_utils_keybinding_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "BirdieUtilsKeybindingManager", &g_define_type_info, 0);
		g_once_init_leave (&birdie_utils_keybinding_manager_type_id__volatile, birdie_utils_keybinding_manager_type_id);
	}
	return birdie_utils_keybinding_manager_type_id__volatile;
}



